unit Mak_met;

interface

const n=30; // sko-ko max v tablice

type cherta = (none,punktir,full);
     koord_ar = record
                 st:byte;
                 stl:byte;
                end;
     matr_a = array[1..n] of byte;

//////////////////////////////////////////////////////
     Element= object
     private
       znach: real;    //znachnie, kotoroe v algoritme budet meniatsia
       znach_old: real;  // ishodnoe znachenie
       podcherk: cherta;  // kak podcherknuto
     public
        procedure set_znach(Z:real);
        procedure set_old_znach(Z:real);
        procedure set_cherta(Z:cherta);
        function get_znach():real;
        function get_old_znach():real;
        function get_cherta():cherta;
     end;
//////////////////////////////////////////////////

Matrix = array[1..n,1..n] of Element;

//////////////////////////////////////////////
 procedure ProvVihod(var stop:boolean;tb:matrix;max_n:byte);
 procedure FindMin(var tb:matrix;max_n:byte);
 procedure ChooseToA(var A:matr_a;var in_a:byte;tb:matrix;max_n:byte);
 procedure FindAr(var ar:koord_ar;var  ar_br:real;tb:matrix;max_n,in_a:byte;A:matr_a);
 procedure IncInA(var tb:matrix;ar_br:real; A:matr_a;max_n,in_a:byte;ar:koord_ar);
 procedure MarkAr(var tb:matrix;ar:koord_ar);
 procedure AboutC(tb:matrix;ar:koord_ar;var c_ok:boolean;var a:matr_a;var in_a,max_n:byte);
 procedure PodcherkAr(var tb:matrix;ar:koord_ar);
 procedure DelPodcherk(var tb:matrix;var d:byte;ar:koord_ar;max_n:byte);
 procedure FindInD(var ar_ok:boolean;d:byte;tb:matrix;max_n:byte; var ar:koord_ar);
/////////////////////////////////////////////////////

implementation

//////////////////////////////////////////////////////////
  procedure Element.set_znach(Z:real);
  begin
    znach:=z;
  end;

  procedure Element.set_old_znach(Z:real);
  begin
    znach_old:=z;
  end;

  procedure Element.set_cherta(Z:cherta);
  begin
    podcherk:=z;
  end;

  function Element.get_znach():real;
  begin
    get_znach:=znach;
  end;

  function Element.get_old_znach():real;
  begin
    get_old_znach:=znach_old;
  end;

  function Element.get_cherta():cherta;
  begin
    get_cherta:=podcherk;
  end;
////////////////////////////////////////////////////////////////

procedure ProvVihod (var stop:boolean; tb:matrix; max_n:byte);
var i,j,kol: byte;
    lg: boolean;
begin
  kol:=0;
  for j:=1 to max_n do
  begin
    lg:=false;
    for i:=1 to max_n do
    if tb[i,j].get_cherta=full then lg:=true;
    if lg then inc(kol);
  end;
  if kol=max_n then stop:=true;
end;

procedure FindMin(var tb: matrix; max_n: byte);
var i,j,stlb: byte;
    min: real;
begin
  for i:=1 to max_n do
  begin
    min:=10000;
    stlb:=1;
    for j:=1 to max_n do
    if tb[i,j].get_znach<min then
    begin
      min:=tb[i,j].get_znach;
      stlb:=j;
    end;
    tb[i,stlb].set_cherta(full);
  end;
end;

procedure ChooseToA(var A:matr_a; var in_a:byte; tb:matrix; max_n:byte);
var i,j: byte;
    kol_vo: byte;
begin
  in_a:=0;
  for j:=max_n downto 1 do
  begin
    kol_vo:=0;
    for i:=1 to max_n do
    if tb[i,j].get_cherta=full then inc(kol_vo);
    if kol_vo>1 then
    begin
      inc(in_a);
      A[in_a]:=j;
     end;
  end;
end;

procedure FindAr(var ar:koord_ar; var  ar_br:real; tb:matrix; max_n,in_a:byte; A:matr_a);
var i,j,k,stl: byte;
    min,min2: real;
    lg: boolean;
begin
  min2:=100000;
  for i:=1 to max_n do
  begin
    min:=10000;
    for j:=1 to max_n do
    begin
      lg:=false;
      for k:=1 to in_a do if A[k]=j then lg:=true;
      if not(lg) then
      if tb[i,j].get_znach<min then
      begin
        stl:=j;
        min:=tb[i,j].get_znach;
      end;
    end;
    for k:=1 to in_a do
    if tb[i,A[k]].get_cherta=full then
    if (tb[i,stl].get_znach-tb[i,A[k]].get_znach)<min2 then
    begin
      min2:=tb[i,stl].get_znach-tb[i,A[k]].get_znach;
      ar.st:=i;
      ar.stl:=stl;
      ar_br:=min2;
    end;
  end;
end;

procedure IncInA(var tb:matrix; ar_br:real; A:matr_a; max_n,in_a:byte; ar:koord_ar);
var i,j:byte;
begin
  for i:=1 to max_n do
  for j:=1 to in_a do
    tb[i,A[j]].set_znach(tb[i,A[j]].get_znach+ar_br);
end;

procedure MarkAr(var tb:matrix; ar:koord_ar);
begin
  tb[ar.st,ar.stl].set_cherta(punktir);
end;

procedure AboutC(tb:matrix; ar:koord_ar; var c_ok:boolean; var a:matr_a; var in_a,max_n:byte);
var i,kol: byte;
begin
  kol:=0;
  for i:=1 to max_n do
  if tb[i,ar.stl].get_cherta=full then inc(kol);
  if kol>0 then
  begin
   inc(in_a);
   a[in_a]:=ar.stl;
   c_ok:=false;
  end;
end;

procedure PodcherkAr(var tb:matrix; ar:koord_ar);
begin
  tb[ar.st,ar.stl].set_cherta(full);
end;

procedure DelPodcherk(var tb:matrix; var d:byte; ar:koord_ar; max_n:byte);
var j: byte;
begin
  for j:=1 to max_n do
  if j<>ar.stl then
  if tb[ar.st,j].get_cherta=full then
  begin
    tb[ar.st,j].set_cherta(none);
    d:=j;
  end;
end;

procedure FindInD(var ar_ok:boolean; d:byte; tb:matrix; max_n:byte; var ar:koord_ar);
var i: byte;
begin
  ar_ok:=true;
  for i:=1 to max_n do
  if tb[i,d].get_cherta=punktir then
  begin
    ar.st:=i;
    ar.stl:=d;
    ar_ok:=false;
  end;
end;

end.
